Linux Audio

Check our new training course

Loading...
v4.17
  1# SPDX-License-Identifier: GPL-2.0
  2# Most of this file is copied from tools/lib/traceevent/Makefile
  3
  4BPF_VERSION = 0
  5BPF_PATCHLEVEL = 0
  6BPF_EXTRAVERSION = 1
 
 
 
 
 
 
  7
  8MAKEFLAGS += --no-print-directory
  9
 10ifeq ($(srctree),)
 
 
 
 
 11srctree := $(patsubst %/,%,$(dir $(CURDIR)))
 12srctree := $(patsubst %/,%,$(dir $(srctree)))
 13srctree := $(patsubst %/,%,$(dir $(srctree)))
 14#$(info Determined 'srctree' to be $(srctree))
 15endif
 16
 17# Makefiles suck: This macro sets a default value of $(2) for the
 18# variable named by $(1), unless the variable has been set by
 19# environment or command line. This is necessary for CC and AR
 20# because make sets default values, so the simpler ?= approach
 21# won't work as expected.
 22define allow-override
 23  $(if $(or $(findstring environment,$(origin $(1))),\
 24            $(findstring command line,$(origin $(1)))),,\
 25    $(eval $(1) = $(2)))
 26endef
 27
 28# Allow setting CC and AR, or setting CROSS_COMPILE as a prefix.
 29$(call allow-override,CC,$(CROSS_COMPILE)gcc)
 30$(call allow-override,AR,$(CROSS_COMPILE)ar)
 31
 32INSTALL = install
 33
 34# Use DESTDIR for installing into a different root directory.
 35# This is useful for building a package. The program will be
 36# installed in this directory as if it was the root directory.
 37# Then the build tool can move it later.
 38DESTDIR ?=
 39DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'
 40
 41include $(srctree)/tools/scripts/Makefile.arch
 42
 43ifeq ($(LP64), 1)
 44  libdir_relative = lib64
 45else
 46  libdir_relative = lib
 47endif
 48
 49prefix ?= /usr/local
 50libdir = $(prefix)/$(libdir_relative)
 51man_dir = $(prefix)/share/man
 52man_dir_SQ = '$(subst ','\'',$(man_dir))'
 53
 54export man_dir man_dir_SQ INSTALL
 55export DESTDIR DESTDIR_SQ
 56
 57include ../../scripts/Makefile.include
 58
 59# copy a bit from Linux kbuild
 60
 61ifeq ("$(origin V)", "command line")
 62  VERBOSE = $(V)
 63endif
 64ifndef VERBOSE
 65  VERBOSE = 0
 66endif
 67
 68FEATURE_USER = .libbpf
 69FEATURE_TESTS = libelf libelf-getphdrnum libelf-mmap bpf
 70FEATURE_DISPLAY = libelf bpf
 71
 72INCLUDES = -I. -I$(srctree)/tools/include -I$(srctree)/tools/arch/$(ARCH)/include/uapi -I$(srctree)/tools/include/uapi
 73FEATURE_CHECK_CFLAGS-bpf = $(INCLUDES)
 74
 75check_feat := 1
 76NON_CHECK_FEAT_TARGETS := clean TAGS tags cscope help
 77ifdef MAKECMDGOALS
 78ifeq ($(filter-out $(NON_CHECK_FEAT_TARGETS),$(MAKECMDGOALS)),)
 79  check_feat := 0
 80endif
 81endif
 82
 83ifeq ($(check_feat),1)
 84ifeq ($(FEATURES_DUMP),)
 85include $(srctree)/tools/build/Makefile.feature
 86else
 87include $(FEATURES_DUMP)
 88endif
 89endif
 90
 91export prefix libdir src obj
 92
 93# Shell quotes
 94libdir_SQ = $(subst ','\'',$(libdir))
 95libdir_relative_SQ = $(subst ','\'',$(libdir_relative))
 96
 97LIB_FILE = libbpf.a libbpf.so
 98
 99VERSION		= $(BPF_VERSION)
100PATCHLEVEL	= $(BPF_PATCHLEVEL)
101EXTRAVERSION	= $(BPF_EXTRAVERSION)
102
103OBJ		= $@
104N		=
105
106LIBBPF_VERSION = $(BPF_VERSION).$(BPF_PATCHLEVEL).$(BPF_EXTRAVERSION)
 
 
107
108# Set compile option CFLAGS
109ifdef EXTRA_CFLAGS
110  CFLAGS := $(EXTRA_CFLAGS)
111else
112  CFLAGS := -g -Wall
113endif
114
115ifeq ($(feature-libelf-mmap), 1)
116  override CFLAGS += -DHAVE_LIBELF_MMAP_SUPPORT
117endif
118
119ifeq ($(feature-libelf-getphdrnum), 1)
120  override CFLAGS += -DHAVE_ELF_GETPHDRNUM_SUPPORT
121endif
122
123# Append required CFLAGS
124override CFLAGS += $(EXTRA_WARNINGS)
 
125override CFLAGS += -Werror -Wall
126override CFLAGS += -fPIC
127override CFLAGS += $(INCLUDES)
 
 
 
 
 
 
128
129ifeq ($(VERBOSE),1)
130  Q =
131else
132  Q = @
133endif
134
135# Disable command line variables (CFLAGS) override from top
136# level Makefile (perf), otherwise build Makefile will get
137# the same command line setup.
138MAKEOVERRIDES=
139
140all:
141
 
 
142export srctree OUTPUT CC LD CFLAGS V
143include $(srctree)/tools/build/Makefile.include
144
145BPF_IN    := $(OUTPUT)libbpf-in.o
146LIB_FILE := $(addprefix $(OUTPUT),$(LIB_FILE))
147
148CMD_TARGETS = $(LIB_FILE)
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
149
150TARGETS = $(CMD_TARGETS)
151
152all: fixdep all_cmd
 
153
154all_cmd: $(CMD_TARGETS)
155
156$(BPF_IN): force elfdep bpfdep
157	@(test -f ../../include/uapi/linux/bpf.h -a -f ../../../include/uapi/linux/bpf.h && ( \
158	(diff -B ../../include/uapi/linux/bpf.h ../../../include/uapi/linux/bpf.h >/dev/null) || \
159	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf.h' differs from latest version at 'include/uapi/linux/bpf.h'" >&2 )) || true
160	@(test -f ../../include/uapi/linux/bpf_common.h -a -f ../../../include/uapi/linux/bpf_common.h && ( \
161	(diff -B ../../include/uapi/linux/bpf_common.h ../../../include/uapi/linux/bpf_common.h >/dev/null) || \
162	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf_common.h' differs from latest version at 'include/uapi/linux/bpf_common.h'" >&2 )) || true
163	@(test -f ../../include/uapi/linux/netlink.h -a -f ../../../include/uapi/linux/netlink.h && ( \
164	(diff -B ../../include/uapi/linux/netlink.h ../../../include/uapi/linux/netlink.h >/dev/null) || \
165	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/netlink.h' differs from latest version at 'include/uapi/linux/netlink.h'" >&2 )) || true
166	@(test -f ../../include/uapi/linux/if_link.h -a -f ../../../include/uapi/linux/if_link.h && ( \
167	(diff -B ../../include/uapi/linux/if_link.h ../../../include/uapi/linux/if_link.h >/dev/null) || \
168	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_link.h' differs from latest version at 'include/uapi/linux/if_link.h'" >&2 )) || true
169	$(Q)$(MAKE) $(build)=libbpf
170
171$(OUTPUT)libbpf.so: $(BPF_IN)
172	$(QUIET_LINK)$(CC) --shared $^ -o $@
173
174$(OUTPUT)libbpf.a: $(BPF_IN)
175	$(QUIET_LINK)$(RM) $@; $(AR) rcs $@ $^
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
176
177define do_install
178	if [ ! -d '$(DESTDIR_SQ)$2' ]; then		\
179		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2';	\
180	fi;						\
181	$(INSTALL) $1 $(if $3,-m $3,) '$(DESTDIR_SQ)$2'
182endef
183
184install_lib: all_cmd
185	$(call QUIET_INSTALL, $(LIB_FILE)) \
186		$(call do_install,$(LIB_FILE),$(libdir_SQ))
187
188install_headers:
189	$(call QUIET_INSTALL, headers) \
190		$(call do_install,bpf.h,$(prefix)/include/bpf,644); \
191		$(call do_install,libbpf.h,$(prefix)/include/bpf,644);
192
193install: install_lib
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
194
195### Cleaning rules
196
197config-clean:
198	$(call QUIET_CLEAN, config)
199	$(Q)$(MAKE) -C $(srctree)/tools/build/feature/ clean >/dev/null
200
201clean:
202	$(call QUIET_CLEAN, libbpf) $(RM) *.o *~ $(TARGETS) *.a *.so .*.d .*.cmd \
203		$(RM) LIBBPF-CFLAGS
204	$(call QUIET_CLEAN, core-gen) $(RM) $(OUTPUT)FEATURE-DUMP.libbpf
205
206
207
208PHONY += force elfdep bpfdep
209force:
210
211elfdep:
212	@if [ "$(feature-libelf)" != "1" ]; then echo "No libelf found"; exit 1 ; fi
213
214bpfdep:
215	@if [ "$(feature-bpf)" != "1" ]; then echo "BPF API too old"; exit 1 ; fi
 
 
216
217# Declare the contents of the .PHONY variable as phony.  We keep that
218# information in a variable so we can use it in if_changed and friends.
219.PHONY: $(PHONY)
v6.13.7
  1# SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
  2# Most of this file is copied from tools/lib/traceevent/Makefile
  3
  4RM ?= rm
  5srctree := $(realpath $(srctree))
  6
  7VERSION_SCRIPT := libbpf.map
  8LIBBPF_VERSION := $(shell \
  9	grep -oE '^LIBBPF_([0-9.]+)' $(VERSION_SCRIPT) | \
 10	sort -rV | head -n1 | cut -d'_' -f2)
 11LIBBPF_MAJOR_VERSION := $(word 1,$(subst ., ,$(LIBBPF_VERSION)))
 12LIBBPF_MINOR_VERSION := $(word 2,$(subst ., ,$(LIBBPF_VERSION)))
 13
 14MAKEFLAGS += --no-print-directory
 15
 16# This will work when bpf is built in tools env. where srctree
 17# isn't set and when invoked from selftests build, where srctree
 18# is a ".". building_out_of_srctree is undefined for in srctree
 19# builds
 20ifndef building_out_of_srctree
 21srctree := $(patsubst %/,%,$(dir $(CURDIR)))
 22srctree := $(patsubst %/,%,$(dir $(srctree)))
 23srctree := $(patsubst %/,%,$(dir $(srctree)))
 24#$(info Determined 'srctree' to be $(srctree))
 25endif
 26
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 27INSTALL = install
 28
 29# Use DESTDIR for installing into a different root directory.
 30# This is useful for building a package. The program will be
 31# installed in this directory as if it was the root directory.
 32# Then the build tool can move it later.
 33DESTDIR ?=
 34DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'
 35
 36include $(srctree)/tools/scripts/Makefile.arch
 37
 38ifeq ($(LP64), 1)
 39  libdir_relative = lib64
 40else
 41  libdir_relative = lib
 42endif
 43
 44prefix ?= /usr/local
 45libdir = $(prefix)/$(libdir_relative)
 46man_dir = $(prefix)/share/man
 47man_dir_SQ = '$(subst ','\'',$(man_dir))'
 48
 49export man_dir man_dir_SQ INSTALL
 50export DESTDIR DESTDIR_SQ
 51
 52include $(srctree)/tools/scripts/Makefile.include
 53
 54# copy a bit from Linux kbuild
 55
 56ifeq ("$(origin V)", "command line")
 57  VERBOSE = $(V)
 58endif
 59ifndef VERBOSE
 60  VERBOSE = 0
 61endif
 62
 63INCLUDES = -I$(or $(OUTPUT),.) \
 64	   -I$(srctree)/tools/include -I$(srctree)/tools/include/uapi \
 65	   -I$(srctree)/tools/arch/$(SRCARCH)/include
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 66
 67export prefix libdir src obj
 68
 69# Shell quotes
 70libdir_SQ = $(subst ','\'',$(libdir))
 71libdir_relative_SQ = $(subst ','\'',$(libdir_relative))
 72
 
 
 
 
 
 
 73OBJ		= $@
 74N		=
 75
 76LIB_TARGET	= libbpf.a libbpf.so.$(LIBBPF_VERSION)
 77LIB_FILE	= libbpf.a libbpf.so*
 78PC_FILE		= libbpf.pc
 79
 80# Set compile option CFLAGS
 81ifdef EXTRA_CFLAGS
 82  CFLAGS := $(EXTRA_CFLAGS)
 83else
 84  CFLAGS := -g -O2
 
 
 
 
 
 
 
 
 85endif
 86
 87# Append required CFLAGS
 88override CFLAGS += -std=gnu89
 89override CFLAGS += $(EXTRA_WARNINGS) -Wno-switch-enum
 90override CFLAGS += -Werror -Wall
 
 91override CFLAGS += $(INCLUDES)
 92override CFLAGS += -fvisibility=hidden
 93override CFLAGS += -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
 94override CFLAGS += $(CLANG_CROSS_FLAGS)
 95
 96# flags specific for shared library
 97SHLIB_FLAGS := -DSHARED -fPIC
 98
 99ifeq ($(VERBOSE),1)
100  Q =
101else
102  Q = @
103endif
104
105# Disable command line variables (CFLAGS) override from top
106# level Makefile (perf), otherwise build Makefile will get
107# the same command line setup.
108MAKEOVERRIDES=
109
110all:
111
112OUTPUT ?= ./
113OUTPUT := $(abspath $(OUTPUT))/
114export srctree OUTPUT CC LD CFLAGS V
115include $(srctree)/tools/build/Makefile.include
116
117SHARED_OBJDIR	:= $(OUTPUT)sharedobjs/
118STATIC_OBJDIR	:= $(OUTPUT)staticobjs/
119BPF_IN_SHARED	:= $(SHARED_OBJDIR)libbpf-in.o
120BPF_IN_STATIC	:= $(STATIC_OBJDIR)libbpf-in.o
121BPF_HELPER_DEFS	:= $(OUTPUT)bpf_helper_defs.h
122BPF_GENERATED	:= $(BPF_HELPER_DEFS)
123
124LIB_TARGET	:= $(addprefix $(OUTPUT),$(LIB_TARGET))
125LIB_FILE	:= $(addprefix $(OUTPUT),$(LIB_FILE))
126PC_FILE		:= $(addprefix $(OUTPUT),$(PC_FILE))
127
128TAGS_PROG := $(if $(shell which etags 2>/dev/null),etags,ctags)
129
130GLOBAL_SYM_COUNT = $(shell readelf -s --wide $(BPF_IN_SHARED) | \
131			   cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' | \
132			   sed 's/\[.*\]//' | \
133			   awk '/GLOBAL/ && /DEFAULT && !/UND|ABS/ {print $$NF}' | \
134			   sort -u | wc -l)
135VERSIONED_SYM_COUNT = $(shell readelf --dyn-syms --wide $(OUTPUT)libbpf.so | \
136			      sed 's/\[.*\]//' | \
137			      awk '/GLOBAL/ && /DEFAULT/ && !/UND|ABS/ {print $$NF}' | \
138			      grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 | sort -u | wc -l)
139
140CMD_TARGETS = $(LIB_TARGET) $(PC_FILE)
141
142all: fixdep
143	$(Q)$(MAKE) all_cmd
144
145all_cmd: $(CMD_TARGETS) check
146
147$(SHARED_OBJDIR) $(STATIC_OBJDIR):
148	$(Q)mkdir -p $@
149
150$(BPF_IN_SHARED): force $(BPF_GENERATED) | $(SHARED_OBJDIR)
 
 
151	@(test -f ../../include/uapi/linux/bpf.h -a -f ../../../include/uapi/linux/bpf.h && ( \
152	(diff -B ../../include/uapi/linux/bpf.h ../../../include/uapi/linux/bpf.h >/dev/null) || \
153	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf.h' differs from latest version at 'include/uapi/linux/bpf.h'" >&2 )) || true
154	@(test -f ../../include/uapi/linux/bpf_common.h -a -f ../../../include/uapi/linux/bpf_common.h && ( \
155	(diff -B ../../include/uapi/linux/bpf_common.h ../../../include/uapi/linux/bpf_common.h >/dev/null) || \
156	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf_common.h' differs from latest version at 'include/uapi/linux/bpf_common.h'" >&2 )) || true
157	@(test -f ../../include/uapi/linux/if_xdp.h -a -f ../../../include/uapi/linux/if_xdp.h && ( \
158	(diff -B ../../include/uapi/linux/if_xdp.h ../../../include/uapi/linux/if_xdp.h >/dev/null) || \
159	echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_xdp.h' differs from latest version at 'include/uapi/linux/if_xdp.h'" >&2 )) || true
160	$(SILENT_MAKE) -C $(srctree)/tools/build CFLAGS= LDFLAGS= OUTPUT=$(SHARED_OBJDIR) $(SHARED_OBJDIR)fixdep
161	$(Q)$(MAKE) $(build)=libbpf OUTPUT=$(SHARED_OBJDIR) CFLAGS="$(CFLAGS) $(SHLIB_FLAGS)"
162
163$(BPF_IN_STATIC): force $(BPF_GENERATED) | $(STATIC_OBJDIR)
164	$(SILENT_MAKE) -C $(srctree)/tools/build CFLAGS= LDFLAGS= OUTPUT=$(STATIC_OBJDIR) $(STATIC_OBJDIR)fixdep
165	$(Q)$(MAKE) $(build)=libbpf OUTPUT=$(STATIC_OBJDIR)
166
167$(BPF_HELPER_DEFS): $(srctree)/tools/include/uapi/linux/bpf.h
168	$(QUIET_GEN)$(srctree)/scripts/bpf_doc.py --header \
169		--file $(srctree)/tools/include/uapi/linux/bpf.h > $(BPF_HELPER_DEFS)
170
171$(OUTPUT)libbpf.so: $(OUTPUT)libbpf.so.$(LIBBPF_VERSION)
172
173$(OUTPUT)libbpf.so.$(LIBBPF_VERSION): $(BPF_IN_SHARED) $(VERSION_SCRIPT)
174	$(QUIET_LINK)$(CC) $(CFLAGS) $(LDFLAGS) \
175		--shared -Wl,-soname,libbpf.so.$(LIBBPF_MAJOR_VERSION) \
176		-Wl,--version-script=$(VERSION_SCRIPT) $< -lelf -lz -o $@
177	@ln -sf $(@F) $(OUTPUT)libbpf.so
178	@ln -sf $(@F) $(OUTPUT)libbpf.so.$(LIBBPF_MAJOR_VERSION)
179
180$(OUTPUT)libbpf.a: $(BPF_IN_STATIC)
181	$(QUIET_LINK)$(RM) -f $@; $(AR) rcs $@ $^
182
183$(OUTPUT)libbpf.pc:
184	$(QUIET_GEN)sed -e "s|@PREFIX@|$(prefix)|" \
185		-e "s|@LIBDIR@|$(libdir_SQ)|" \
186		-e "s|@VERSION@|$(LIBBPF_VERSION)|" \
187		< libbpf.pc.template > $@
188
189check: check_abi check_version
190
191check_abi: $(OUTPUT)libbpf.so $(VERSION_SCRIPT)
192	@if [ "$(GLOBAL_SYM_COUNT)" != "$(VERSIONED_SYM_COUNT)" ]; then	 \
193		echo "Warning: Num of global symbols in $(BPF_IN_SHARED)"	 \
194		     "($(GLOBAL_SYM_COUNT)) does NOT match with num of"	 \
195		     "versioned symbols in $^ ($(VERSIONED_SYM_COUNT))." \
196		     "Please make sure all LIBBPF_API symbols are"	 \
197		     "versioned in $(VERSION_SCRIPT)." >&2;		 \
198		readelf -s --wide $(BPF_IN_SHARED) |			 \
199		    cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' |	 \
200		    sed 's/\[.*\]//' |					 \
201		    awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}'|  \
202		    sort -u > $(OUTPUT)libbpf_global_syms.tmp;		 \
203		readelf --dyn-syms --wide $(OUTPUT)libbpf.so |		 \
204		    sed 's/\[.*\]//' |					 \
205		    awk '/GLOBAL/ && /DEFAULT/ && !/UND|ABS/ {print $$NF}'|  \
206		    grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 |		 \
207		    sort -u > $(OUTPUT)libbpf_versioned_syms.tmp; 	 \
208		diff -u $(OUTPUT)libbpf_global_syms.tmp			 \
209		     $(OUTPUT)libbpf_versioned_syms.tmp;		 \
210		rm $(OUTPUT)libbpf_global_syms.tmp			 \
211		   $(OUTPUT)libbpf_versioned_syms.tmp;			 \
212		exit 1;							 \
213	fi
214
215HDR_MAJ_VERSION := $(shell grep -oE '^$(pound)define LIBBPF_MAJOR_VERSION ([0-9]+)$$' libbpf_version.h | cut -d' ' -f3)
216HDR_MIN_VERSION := $(shell grep -oE '^$(pound)define LIBBPF_MINOR_VERSION ([0-9]+)$$' libbpf_version.h | cut -d' ' -f3)
217
218check_version: $(VERSION_SCRIPT) libbpf_version.h
219	@if [ "$(HDR_MAJ_VERSION)" != "$(LIBBPF_MAJOR_VERSION)" ]; then        \
220		echo "Error: libbpf major version mismatch detected: "	       \
221		     "'$(HDR_MAJ_VERSION)' != '$(LIBBPF_MAJOR_VERSION)'" >&2;  \
222		exit 1;							       \
223	fi
224	@if [ "$(HDR_MIN_VERSION)" != "$(LIBBPF_MINOR_VERSION)" ]; then	       \
225		echo "Error: libbpf minor version mismatch detected: "	       \
226		     "'$(HDR_MIN_VERSION)' != '$(LIBBPF_MINOR_VERSION)'" >&2;  \
227		exit 1;							       \
228	fi
229
230define do_install_mkdir
231	if [ ! -d '$(DESTDIR_SQ)$1' ]; then		\
232		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$1';	\
233	fi
234endef
235
236define do_install
237	if [ ! -d '$(DESTDIR_SQ)$2' ]; then		\
238		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2';	\
239	fi;						\
240	$(INSTALL) $(if $3,-m $3,) $1 '$(DESTDIR_SQ)$2'
241endef
242
243install_lib: all_cmd
244	$(call QUIET_INSTALL, $(LIB_TARGET)) \
245		$(call do_install_mkdir,$(libdir_SQ)); \
246		cp -fpR $(LIB_FILE) $(DESTDIR)$(libdir_SQ)
247
248SRC_HDRS := bpf.h libbpf.h btf.h libbpf_common.h libbpf_legacy.h	     \
249	    bpf_helpers.h bpf_tracing.h bpf_endian.h bpf_core_read.h	     \
250	    skel_internal.h libbpf_version.h usdt.bpf.h
251GEN_HDRS := $(BPF_GENERATED)
252
253INSTALL_PFX := $(DESTDIR)$(prefix)/include/bpf
254INSTALL_SRC_HDRS := $(addprefix $(INSTALL_PFX)/, $(SRC_HDRS))
255INSTALL_GEN_HDRS := $(addprefix $(INSTALL_PFX)/, $(notdir $(GEN_HDRS)))
256
257$(INSTALL_SRC_HDRS): $(INSTALL_PFX)/%.h: %.h
258	$(call QUIET_INSTALL, $@) \
259		$(call do_install,$<,$(prefix)/include/bpf,644)
260
261$(INSTALL_GEN_HDRS): $(INSTALL_PFX)/%.h: $(OUTPUT)%.h
262	$(call QUIET_INSTALL, $@) \
263		$(call do_install,$<,$(prefix)/include/bpf,644)
264
265install_headers: $(BPF_GENERATED) $(INSTALL_SRC_HDRS) $(INSTALL_GEN_HDRS)
266	$(call QUIET_INSTALL, libbpf_headers)
267
268install_pkgconfig: $(PC_FILE)
269	$(call QUIET_INSTALL, $(PC_FILE)) \
270		$(call do_install,$(PC_FILE),$(libdir_SQ)/pkgconfig,644)
271
272install: install_lib install_pkgconfig install_headers
273
274clean: fixdep-clean
275	$(call QUIET_CLEAN, libbpf) $(RM) -rf $(CMD_TARGETS)		     \
276		*~ .*.d .*.cmd LIBBPF-CFLAGS $(BPF_GENERATED)		     \
277		$(SHARED_OBJDIR) $(STATIC_OBJDIR)			     \
278		$(addprefix $(OUTPUT),					     \
279			    *.o *.a *.so *.so.$(LIBBPF_MAJOR_VERSION) *.pc)
280
281PHONY += force cscope tags check check_abi check_version
 
 
 
 
 
 
 
 
 
 
 
 
 
282force:
283
284cscope:
285	ls *.c *.h > cscope.files
286	cscope -b -q -I $(srctree)/include -f cscope.out
287
288tags:
289	$(RM) -f TAGS tags
290	ls *.c *.h | xargs $(TAGS_PROG) -a
291
292# Declare the contents of the .PHONY variable as phony.  We keep that
293# information in a variable so we can use it in if_changed and friends.
294.PHONY: $(PHONY)
295
296# Delete partially updated (corrupted) files on error
297.DELETE_ON_ERROR:
298
299help:
300	@echo 'libbpf common targets:'
301	@echo '  HINT: use "V=1" to enable verbose build'
302	@echo '  all     - build libraries and pkgconfig'
303	@echo '  clean   - remove all generated files'
304	@echo '  check   - check ABI and version info'
305	@echo ''
306	@echo 'libbpf install targets:'
307	@echo '  HINT: use "prefix"(defaults to "/usr/local") or "DESTDIR" (defaults to "/")'
308	@echo '        to adjust target destination, e.g. "make prefix=/usr/local install"'
309	@echo '  install          - build and install all headers, libraries and pkgconfig'
310	@echo '  install_headers  - install only headers to include/bpf'
311	@echo ''
312	@echo 'libbpf make targets:'
313	@echo '  tags    - use ctags to make tag information for source code browsing'
314	@echo '  cscope  - use cscope to make interactive source code browsing database'